<?php
if(!isset($id)) $id = '';
if(!isset($label)) $label = '';
if(!isset($class_chain)) $class_chain = '';
if(!isset($name)) $name = '';
if(!isset($error)) $error = '';
if(!isset($value)) $value = '';
if(!isset($repeatable)) $repeatable = '';
if(!isset($affectable)) $affectable = '';
if(!isset($inlineblock)) $inlineblock = '';
if(!isset($affects)) $affects = '';
if(!isset($table)) $table = '';
if(!isset($options)) $options = array();
if(!isset($affected_by)) $affected_by = '';

global $opened;


/** if doesn't affect any child selector and has 0 options, do not display **/
if(!(!!$affects) && count($options) == 0) {

	return;
}


$specialBehavior = false;
if(!!$affectable || !!$affects) {
    // [todo] the label needs better position
    $specialBehavior = true;
}
?>
<!-- if has affects or affectable -->

<?php if(!$specialBehavior || ($specialBehavior && ($affects && !$affectable))): 
    // if affects and not affectable, start div -->
    echo "<!-- [START][v-$id] -->";
    echo "<div><span class='starter'></span>";
    $opened = true;
endif;
?>

<?php
if(count($options) == 0 && !$affectable):
    if($label):
        echo "<label for='$id'>$label</label>";
    endif;
return;
endif;
if(count($options) == 1) $value = $options[0]['value'];
?>

<span
    <?php 
    if($affectable && $value) { echo "class='js-selector affectable js-container'" ; } 
            elseif($affectable) { echo "style='display: none;' class='js-selector affectable js-container'" ; }
            elseif($inlineblock) { echo "style='display: inline-block;' class='js-selector js-container'" ; }
    ?>
    >
    
<?php if($label): ?>
    <label for="<?php echo $id; ?>"><?php echo $label; ?></label>
<?php endif; ?>

<select <?php echo "data-affectedby='$affected_by'"; ?> <?php if($value) echo "data-should_select='$value'"; ?> <?php if(isset($child)) echo "data-child='$child'";?>   <?php if(count($options) == 1) {echo "style='display: none;'";}; ?> <?php if(@$disabled) echo 'disabled'; ?> data-table="<?php echo $table;?>" <?php if($affects) echo "data-affects='$affects'"; ?> class="<?php echo $class_chain; ?>" id="<?php echo $id; ?>" name="<?php echo $name; ?>">
	<option></option>
	<?php 
      $gotSelected = false;
	  foreach($options as $option): 
		  $selected = '';
		  if($value == $option['value']):
			  $selected = 'selected';
              $gotSelected = true;
		  endif;
	
		 echo "<option $selected value='{$option['value']}'>{$option['label']}</option>";
	 endforeach; ?>
</select>
<i class="fa fa-refresh fa-spin wait" style="display: none;"></i>
</span>
<?php if(!$specialBehavior || ($specialBehavior && (!$affects && $affectable))):
    echo "<!-- if affectable and not affects, stop div -->";
    $opened = false;
    echo "<!-- [STOP][v-$id] -->";
    echo "<span class='stopper'></span></div>";
endif;
?>

<?php if($gotSelected): ?>
<script type="text/javascript">
    carerix_jQuery(document).ready(function(e){
        var $ = carerix_jQuery;
        setTimeout(function(){
            
            $('#'+'<?php echo $id; ?>').trigger('change');
        }, 500);
        
        
    });
    
    
</script>
<?php elseif(count($options) == 1): ?>
<script>
    carerix_jQuery(document).ready(function(e){
        
        var $ = carerix_jQuery;
        setTimeout(function(){
            var affects = $('#'+'<?php echo $id; ?>').data('affects');
            $("#"+affects).parent().show();
            $("#"+affects).trigger('change');
        }, 500);
        
        
    });
</script>
<?php endif; ?>

<script>
    carerix_jQuery(document).ready(function(e){
        var $ = carerix_jQuery;
        var currentId = '<?php echo $id; ?>';
        var currentSelector = $('#'+currentId);
        
        var affectedBy = $(currentSelector).data('affectedby');
        if( $('#'+affectedBy).length <= 0 ) {
            
            $(currentSelector).parent('.js-container').show();
        }
    });
</script>

